In Action(最短路+01背包)

来源:互联网 发布:spring的切面编程 编辑:程序博客网 时间:2024/06/01 09:21

In Action

Time Limit: 2000/1000 MS (Java/Others) Memory Limit: 32768/32768 K (Java/Others)
Total Submission(s): 2117 Accepted Submission(s): 701


Problem Description

Since 1945, when the first nuclear bomb was exploded by the Manhattan Project team in the US, the number of nuclear weapons have soared across the globe.
Nowadays,the crazy boy in FZU named AekdyCoin possesses some nuclear weapons and wanna destroy our world. Fortunately, our mysterious spy-net has gotten his plan. Now, we need to stop it.
But the arduous task is obviously not easy. First of all, we know that the operating system of the nuclear weapon consists of some connected electric stations, which forms a huge and complex electric network. Every electric station has its power value. To start the nuclear weapon, it must cost half of the electric network's power. So first of all, we need to make more than half of the power diasbled. Our tanks are ready for our action in the base(ID is 0), and we must drive them on the road. As for a electric station, we control them if and only if our tanks stop there. 1 unit distance costs 1 unit oil. And we have enough tanks to use.
Now our commander wants to know the minimal oil cost in this action.

Input
The first line of the input contains a single integer T, specifying the number of testcase in the file.
For each case, first line is the integer n(1<= n<= 100), m(1<= m<= 10000), specifying the number of the stations(the IDs are 1,2,3...n), and the number of the roads between the station(bi-direction).
Then m lines follow, each line is interger st(0<= st<= n), ed(0<= ed<= n), dis(0<= dis<= 100), specifying the start point, end point, and the distance between.
Then n lines follow, each line is a interger pow(1<= pow<= 100), specifying the electric station's power by ID order.

Output
The minimal oil cost in this action.
If not exist print "impossible"(without quotes).

Sample Input
22 30 2 92 1 31 0 2132 12 1 313

Sample Output
5impossible

Author
Lost@HDU

Source
HDOJ Monthly Contest – 2010.03.06

Recommend
lcy

题意:给出有n+1个地点(包括0,题意从0点出发),给出m条路

           接着有m组数据为起点st,终点ed,和两点的距离

           n行整数,每个整数表示第i个地点所能获得的能量,运输工具能够承受所有能量总和

          由于能量运输过程中会损失一半、所以求当所能量为总能量一半以上时所走的最短路

题解:最短路+01背包

           dis[i]标记到i点时所走过的最短路,再用01背包求解dp[j]=max(dp[j],dp[j-dis[i]]+pow[i])

自己写的吐血。。。。

别人的答案:http://blog.csdn.net/zfz1015/article/details/7860921